//+------------------------------------------------------------------+
//|                                              II_PIP.mq4 Ver.1.10 |
//|                               Copyright 2009Insanity Industries |
//|                                   http://insanityindustries.net/ |
//|                                                                  |
//|  Based on OverLayChart.mq4 from the mql4 codebase                |
//|                                                                  |
//+------------------------------------------------------------------+

//Indicator Properties
#property copyright "Copyright 2009 Insanity Industries"
#property link      "http://insanityindustries.net/"
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 MediumSeaGreen
#property indicator_color2 Crimson
#property indicator_color3 MediumSeaGreen
#property indicator_color4 Crimson
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3


//Indicator Parameters
extern bool use.chart.pair = true;
extern string SubSymbol = "EURUSD";
extern int SubPeriod = 5;
extern color BullBarColor = MediumSeaGreen;
extern color BearBarColor = Crimson;


extern bool show.ask = true;
extern color color_bid = White;
extern color color_ask = Red;

extern double pos.lo = 50;
extern double pos.hi = 33;
extern double head.depth = 3;
extern int draw.first.bar = 53;
extern int bar.limit = 25;
extern int head.text.size = 12;
extern int price.text.size = 8;
extern string head.font = "Arial";
extern string price.font = "Arial";
extern color color_box = White;
extern color color_cell = Black;
extern color color_price = White;
extern color color_hi = MediumBlue;
extern color color_lo = MediumBlue;
extern color color_close = Red;


extern bool show.sweetspot = true;
extern int NumLinesAboveBelow= 100;
extern int SweetSpotMainLevels= 100;
extern color LineColorMain= DimGray;
extern int LineStyleMain= STYLE_SOLID;
extern bool ShowSubLevels= true;
extern int sublevels= 25;
extern color LineColorSub= DimGray;
extern int LineStyleSub= STYLE_DOT;

string TAG = "II_PIP";

//Indicator Buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

int BarsCount;
double CurRangeHigh, CurRangeLow, CurRangeCenter;
double SubRangeHigh, SubRangeLow, SubRangeCenter;
double SubPoint, SubDigit;
double SubOpen, SubHigh, SubLow, SubClose;
double PipsRatio;
double GridPips, GridPrice;
datetime t1,t2;
double p1,p2;
string pair;
int tf;
double SubRangeClose; // current sub close

double point;

int init()
{
   ObDeleteObjectsByPrefix(TAG);

   pair = Symbol();
   tf = Period();
   if(use.chart.pair) SubSymbol = Symbol();
   IndicatorShortName( "OverLay Chart( " + SubSymbol + " )"+SubPeriod );

   SetIndexBuffer( 0, ExtMapBuffer1 );
   SetIndexBuffer( 1, ExtMapBuffer2 );
   SetIndexBuffer( 2, ExtMapBuffer3 );
   SetIndexBuffer( 3, ExtMapBuffer4 );

   SetIndexStyle( 0, DRAW_HISTOGRAM, DRAW_LINE, 1, BullBarColor );
   SetIndexStyle( 1, DRAW_HISTOGRAM, DRAW_LINE, 1, BearBarColor );
   SetIndexStyle ( 2, DRAW_HISTOGRAM, DRAW_LINE, 3, BullBarColor );
   SetIndexStyle( 3, DRAW_HISTOGRAM, DRAW_LINE, 3, BearBarColor );

   SetIndexEmptyValue( 0, 0.0 );
   SetIndexEmptyValue( 1, 0.0 );
   SetIndexEmptyValue( 2, 0.0 );
   SetIndexEmptyValue( 3, 0.0 );

   point = Point;
   if(Digits == 3 || Digits == 5) point*=10;

   return(0);
}

int deinit() 
{
   ObDeleteObjectsByPrefix(TAG);
   return(0);
}



int start() 
{

   int i;
   int bar.offset;
   double pip.offset;
   double vscale = pos.hi/100;

   //Initialize Buffers
	RefreshRates();

   ArrayInitialize( ExtMapBuffer1, 0.0 );
   ArrayInitialize( ExtMapBuffer2, 0.0 );
   ArrayInitialize( ExtMapBuffer3, 0.0 );
   ArrayInitialize( ExtMapBuffer4, 0.0 );


   //Calculate Visible Bars
   BarsCount = WindowBarsPerChart() + 1;
   int FirstBar = WindowFirstVisibleBar();

   int LastBar = FirstBar - BarsCount + 1;
   if ( LastBar < 0 )
   {
      LastBar = 0;
      BarsCount = FirstBar + 1;
   }


   //Calculate Chart Ratio
   CurRangeHigh = High[iHighest(pair, tf, MODE_HIGH, BarsCount, LastBar)];
   CurRangeLow = Low[iLowest(pair, tf, MODE_LOW, BarsCount, LastBar)];
   CurRangeCenter = (CurRangeHigh + CurRangeLow)/2;


      SubRangeHigh = iHigh(SubSymbol, SubPeriod, iHighest( SubSymbol, SubPeriod, MODE_HIGH, bar.limit, 0 ) );
      SubRangeLow = iLow(SubSymbol, SubPeriod, iLowest( SubSymbol, SubPeriod, MODE_LOW, bar.limit, 0 ) );
      SubRangeClose = iClose(SubSymbol, SubPeriod,0);

   SubRangeCenter = (SubRangeHigh + SubRangeLow)/2;
   

   SubPoint = MarketInfo( SubSymbol, MODE_POINT );
   SubDigit = MarketInfo( SubSymbol, MODE_DIGITS );

            //main chart range                  subchart range
   PipsRatio = ((CurRangeHigh-CurRangeLow)  / ( SubRangeHigh - SubRangeLow ))*vscale;// + CurRangeLow;

   pip.offset = CurRangeLow + (SubRangeCenter - SubRangeLow)*PipsRatio + ((CurRangeHigh-CurRangeLow)*pos.lo/100);

//   GridPips = ( SubRangeHigh - SubRangeLow ) / Grid;
//   GridPips = MathRound( ( SubRangeHigh - SubRangeLow ) / Grid / ( SubPoint * SnapPips ) ) * ( SubPoint * SnapPips );


   //Draw Candlesticks
	for ( i = 0; i < bar.limit; i ++ )
	{
	   bar.offset = i+draw.first.bar;
      SubOpen = iOpen(SubSymbol, SubPeriod, i) - SubRangeCenter;
      SubHigh = iHigh(SubSymbol, SubPeriod, i) - SubRangeCenter;
      SubLow =  iLow(SubSymbol, SubPeriod, i) - SubRangeCenter;
      SubClose = iClose(SubSymbol, SubPeriod, i) - SubRangeCenter;
      if(p2<Point) p2 = 1000;
         if ( SubOpen < SubClose )
         {
            ExtMapBuffer1[bar.offset] = pip.offset + SubHigh * PipsRatio;
            if(ExtMapBuffer1[bar.offset] > p1) p1 = ExtMapBuffer1[bar.offset];
            ExtMapBuffer2[bar.offset] = pip.offset + SubLow * PipsRatio;
            if(ExtMapBuffer2[bar.offset] < p2) p2 = ExtMapBuffer2[bar.offset];
         } 
            else
            {
               ExtMapBuffer1[bar.offset] = pip.offset + SubLow * PipsRatio;
               if(ExtMapBuffer1[bar.offset] < p2) p2 = ExtMapBuffer1[bar.offset];
               ExtMapBuffer2[bar.offset] = pip.offset + SubHigh * PipsRatio;
               if(ExtMapBuffer2[bar.offset] > p1) p1 = ExtMapBuffer2[bar.offset];
            }
         ExtMapBuffer3[bar.offset] = pip.offset + SubClose * PipsRatio;
         ExtMapBuffer4[bar.offset] = pip.offset + SubOpen * PipsRatio;
   }

   t1 = Time[draw.first.bar-1];
   t2 = Time[draw.first.bar+bar.limit];


  
   box();
   bidask();
   if(show.sweetspot) SweetSpot();


   return(0);
}
//+------------------------------------------------------------------+

string TimeFrameToString(int t)
{
   string tfs;
   switch(t) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
}


void bidask()
{
   string label = TAG+SubSymbol+SubPeriod+"CLOSELINE";
   if (ObjectFind(label) != 0)
   {
      ObjectCreate(label, OBJ_TREND, 0, 0, 0,0);
      ObjectSet(label, OBJPROP_RAY, false);
      ObjectSet(label, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(label, OBJPROP_COLOR, color_bid);
      ObjectSet(label, OBJPROP_WIDTH, 1);
      ObjectSet(label, OBJPROP_BACK, false);
   }
   else 
   {
      ObjectMove(label, 0, Time[draw.first.bar-2], p2 + (SubRangeClose - SubRangeLow)*PipsRatio);
      ObjectMove(label, 1, Time[draw.first.bar+bar.limit], p2 + (SubRangeClose - SubRangeLow)*PipsRatio);
   }
   label = TAG+SubSymbol+SubPeriod+"CLOSEVAL";
   if (ObjectFind(label) != 0)
   {
      ObjectCreate(label, OBJ_TEXT, 0, 0,0);
      ObjectSetText(label,DoubleToStr(SubRangeClose,Digits),head.text.size,price.font, color_close);
      ObjectSet(label, OBJPROP_BACK, false);
   }
   else 
   {
      ObjectSetText(label,DoubleToStr(SubRangeClose,Digits),head.text.size,price.font, color_close);
      ObjectMove(label, 0, Time[draw.first.bar-5], p2+(SubRangeClose - SubRangeLow)*PipsRatio+(CurRangeHigh-CurRangeLow)*1.6/100);
   }  
}

void box()
{   string label = TAG+SubSymbol+SubPeriod+"RECT";
   ObjectCreate(label,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(label,OBJPROP_BACK, false);
   ObjectSet(label, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(label, OBJPROP_COLOR, color_box);
   ObjectSet(label, OBJPROP_TIME1 , t1);
   ObjectSet(label, OBJPROP_PRICE1, p1);
   ObjectSet(label, OBJPROP_TIME2 , t2);
   ObjectSet(label, OBJPROP_PRICE2, p2);
   label = TAG+SubSymbol+SubPeriod+"RECT2";
   ObjectCreate(label,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(label,OBJPROP_BACK, true);
   ObjectSet(label, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(label, OBJPROP_COLOR, color_cell);
   ObjectSet(label, OBJPROP_TIME1 , t1);
   ObjectSet(label, OBJPROP_PRICE1, p1);
   ObjectSet(label, OBJPROP_TIME2 , t2);
   ObjectSet(label, OBJPROP_PRICE2, p2);
   

   label = TAG+SubSymbol+SubPeriod+"TITLE";
   ObjectCreate(label,OBJ_TEXT,0,0,0);
   ObjectSet(label, OBJPROP_TIME1, Time[draw.first.bar+bar.limit-7]);
   ObjectSet(label, OBJPROP_PRICE1, p1+(CurRangeHigh-CurRangeLow)*head.depth/100);  
   ObjectSetText(label, SubSymbol+" "+TimeFrameToString(SubPeriod), 12,"Arial",Red);   

   label = TAG+SubSymbol+SubPeriod+"TBAR";
   ObjectCreate(label,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(label,OBJPROP_BACK, true);
   ObjectSet(label, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(label, OBJPROP_COLOR, color_cell);
   ObjectSet(label, OBJPROP_TIME1 , t1);
   ObjectSet(label, OBJPROP_PRICE1, p1);
   ObjectSet(label, OBJPROP_TIME2 , t2);
   ObjectSet(label, OBJPROP_PRICE2, p1+(CurRangeHigh-CurRangeLow)*head.depth/100);
   label = TAG+SubSymbol+SubPeriod+"TBAROUTLINE";
   ObjectCreate(label,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(label,OBJPROP_BACK, false);
   ObjectSet(label, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(label, OBJPROP_COLOR, color_box);
   ObjectSet(label, OBJPROP_TIME1 , t1);
   ObjectSet(label, OBJPROP_PRICE1, p1);
   ObjectSet(label, OBJPROP_TIME2 , t2);
   ObjectSet(label, OBJPROP_PRICE2, p1+(CurRangeHigh-CurRangeLow)*head.depth/100);
/*   
   label = TAG+SubSymbol+SubPeriod+"HIDASH";
   if (ObjectFind(label) != 0)
   {
      ObjectCreate(label, OBJ_TREND, 0, 0, 0,0);
      ObjectSet(label, OBJPROP_RAY, false);
      ObjectSet(label, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(label, OBJPROP_COLOR, Black);
      ObjectSet(label, OBJPROP_WIDTH, 1);
      ObjectSet(label, OBJPROP_BACK, false);
   }
   else 
   {
      ObjectMove(label, 0, Time[draw.first.bar-2], p1);
      ObjectMove(label, 1, Time[draw.first.bar-1], p1);
   }    
*/
   label = TAG+SubSymbol+SubPeriod+"HIVAL";
   if (ObjectFind(label) != 0)
   {
      ObjectCreate(label, OBJ_TEXT, 0, 0,0);
      ObjectSetText(label,DoubleToStr(p1,Digits),price.text.size,price.font, color_hi);
      ObjectSet(label, OBJPROP_BACK, false);
   }
   else 
   {
      ObjectSetText(label,DoubleToStr(SubRangeHigh,Digits),price.text.size,price.font, color_hi);
      ObjectMove(label, 0, Time[draw.first.bar-4], p1+(CurRangeHigh-CurRangeLow)*1/100);
   }    
   
/*
   label = TAG+SubSymbol+SubPeriod+"LODASH";
   if (ObjectFind(label) != 0)
   {
      ObjectCreate(label, OBJ_TREND, 0, 0, 0,0);
      ObjectSet(label, OBJPROP_RAY, false);
      ObjectSet(label, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(label, OBJPROP_COLOR, Black);
      ObjectSet(label, OBJPROP_WIDTH, 1);
      ObjectSet(label, OBJPROP_BACK, false);
   }
   else 
   {
      ObjectMove(label, 0, Time[draw.first.bar-2], p2);
      ObjectMove(label, 1, Time[draw.first.bar-1], p2);
   }
*/
   label = TAG+SubSymbol+SubPeriod+"LOVAL";
   if (ObjectFind(label) != 0)
   {
      ObjectCreate(label, OBJ_TEXT, 0, 0,0);
      ObjectSetText(label,DoubleToStr(SubRangeLow,Digits),price.text.size,price.font, color_lo);
      ObjectSet(label, OBJPROP_BACK, false);
   }
   else 
   {
      ObjectSetText(label,DoubleToStr(SubRangeLow,Digits),price.text.size,price.font, color_lo);
      ObjectMove(label, 0, Time[draw.first.bar-4], p2+(CurRangeHigh-CurRangeLow)*1.1/100);
   } 
}

void SweetSpot()
{
   static datetime timelastupdate= 0;
   static datetime lasttimeframe= 0;
    
   if (CurTime()-timelastupdate < 600 && Period()==lasttimeframe)
      return (0);
   
   int i, ssp1, style, ssp, thickness; //sublevels= 50;
   double ds1;
   color linecolor;
   
   if (!ShowSubLevels)
      sublevels*= 2;
   
   ssp1= MarketInfo(SubSymbol,MODE_BID) / point;
   ssp1= ssp1 - ssp1%sublevels;

   for (i= -NumLinesAboveBelow; i<NumLinesAboveBelow; i++) {
   
      ssp= ssp1+(i*sublevels); 
      
      if (ssp%SweetSpotMainLevels==0) {
         style= LineStyleMain;
         linecolor= LineColorMain;
      }
      else {
         style= LineStyleSub;
         linecolor= LineColorSub;
      }
      
      thickness= 1;
      
      if (ssp%(SweetSpotMainLevels*10)==0) {
         thickness= 2;      
      }

      if (ssp%(SweetSpotMainLevels*100)==0) {
         thickness= 3;      
      }
      
      ds1= ssp*point;
      if(ds1 < SubRangeHigh && ds1 > SubRangeLow) SetLevel(DoubleToStr(ds1,Digits), ds1,  linecolor, style, thickness);//, Time[10]);
//      SetLevel(DoubleToStr(ds1,Digits), ds1,  linecolor, style, thickness);
   }
}


void SetLevel(string text, double level, color col1, int linestyle, int thickness)//, datetime startofday)
{
   string linename= TAG+"SS"+SubSymbol+SubPeriod+text;

   if (ObjectFind(linename) != 0) {
      ObjectCreate(linename, OBJ_TREND, 0, 0, 0,0,0);
      ObjectSet(linename, OBJPROP_STYLE, linestyle);
      ObjectSet(linename, OBJPROP_COLOR, col1);
      ObjectSet(linename, OBJPROP_WIDTH, thickness);
      ObjectSet(linename, OBJPROP_BACK, true);
      ObjectSet(linename, OBJPROP_RAY, false);
      
   }
   else {
      ObjectMove(linename, 0, Time[draw.first.bar-1], p2 + (level - SubRangeLow)*PipsRatio);
      ObjectMove(linename, 1, Time[draw.first.bar+bar.limit], p2 + (level - SubRangeLow)*PipsRatio);
   }
}


