//+------------------------------------------------------------------+
//|                                              II_BZ_InfoPanel.mq4 |
//|                            Copyright  2009, Insanity Industries |
//|                                http://www.insanityindustries.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Insanity Industries"
#property link      "http://www.insanityindustries.net"

#property indicator_chart_window

extern int pos.x = 1000;
extern int pos.y = 50;
extern int off.x = 110;
extern int off.y = 55;

extern bool Drop.Shadows = true;
extern int Shadow.Depth = 2;

extern color border_color = SteelBlue;
extern color cell_color = MintCream;
extern color drop_color = DarkGray;

color pair_color = LightSalmon;
extern color ask_head_color = Black;
extern color bid_head_color = Black;
extern color spread_color = Red;
extern color ask1_color = MediumBlue;
color ask2_color = Green;
extern color bid1_color = MediumBlue;
color bid2_color = Green;
color time_color;

extern color Up = LimeGreen;
extern color Eq = DarkGray;
extern color Dn = Red;

extern string BarTimer.FontName="Arial";
extern int BarTimer.FontSize=11;
extern color BarTimer.Color=Black;
int lenbase;
string s_base=":...:...:...:...:";//      

string TAG = "II_Trade_InfoBlock_Lite";

string N_Arrow  = ""; // NORTH
string NE_Arrow = "";  // NORTHEAST
string ENE_Arrow = "";  // EASTNORTHEAST
string E_Arrow  = "";  // EAST
string SE_Arrow = "";  // SOUTHEAST
string ESE_Arrow = "";  // EASTSOUTHEAST
string S_Arrow  = "";  // SOUTH
string NS_Arrow  = "";  // NORTHSOUTH

double lastAsk;
double lastBid;
string pair;
string s[9];
string shortName;
double bid,ask,point;
int lastgapcross;
int lastgaptouch;
datetime H1barstart;

int xpos,ypos,digits,corner,window,mult,xoffset,yoffset;


int init()
{
   ObDeleteObjectsByPrefix(TAG);

   shortName  = TAG;
   IndicatorShortName(shortName);
   corner = 0;
   pair = Symbol();
   digits = Digits;
   point = Point;
   if (digits == 5 || digits == 4) mult = 10000;
   if (digits == 3 || digits == 2) mult = 100;
   if (digits == 5 || digits == 3) point*=10;
   lenbase=StringLen(s_base);

   Comment("");

   return(0);
}

int deinit()
{
   ObDeleteObjectsByPrefix(TAG);

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int x,y;
   xpos = pos.x;
   xoffset = off.x;
   ypos = pos.y+2;
   yoffset = off.y;
   layout(xpos,ypos);
   return(0);
}

void layout(int x, int y)
{
   window = 0; //WindowFind(shortName);
   int i,c;
   string label,time;

   int cell.x = x-13;
   int cell.y = y-30;
   GetSymbolInfo(pair);

   if (Drop.Shadows && ObjectFind(TAG+".A") != 0)
   {
      int xAxis,yAxis;
      if(corner == 0 || corner == 2) {xAxis= cell.x+Shadow.Depth; yAxis=cell.y+Shadow.Depth;}
      if(corner == 1 || corner == 3) {xAxis= cell.x+Shadow.Depth; yAxis=cell.y+Shadow.Depth;}
      
      DrawCell(0, TAG+".A", xAxis, yAxis, 81, 79, drop_color,corner);
   }

   if (ObjectFind(TAG+".Border") == -1) DrawCell(0, TAG+".Border", cell.x, cell.y, 81, 79, border_color,corner);
   if (ObjectFind(TAG+".Box") == -1) DrawCell(0, TAG+".Box", cell.x+1, cell.y+2, 80, 78, cell_color,corner);
   
   time = Clock(pair);
   BarTimer(x,y+62);
   if (Ask > lastAsk) ask2_color = Up;
   if (Ask == lastAsk) ask2_color = Eq;
   if (Ask < lastAsk) ask2_color = Dn;
   if (Bid > lastBid) bid2_color = Up;
   if (Bid == lastBid) bid2_color = Eq;
   if (Bid < lastBid) bid2_color = Dn;
   lastAsk = Ask;
   lastBid = Bid;   
       
   ObjectCreate(TAG+"pair", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"pair", pair, 18, "Arial Bold",  pair_color);
   ObjectSet(TAG+"pair", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"pair", OBJPROP_XDISTANCE, x+1);
   ObjectSet(TAG+"pair", OBJPROP_YDISTANCE, y-1);

   ObjectCreate(TAG+"ask", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"ask", "ASK", 7, "Tahoma",  ask_head_color);
   ObjectSet(TAG+"ask", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"ask", OBJPROP_XDISTANCE, x+71);
   ObjectSet(TAG+"ask", OBJPROP_YDISTANCE, y+22);
       
   ObjectCreate(TAG+"bid", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"bid", "BID", 7, "Tahoma",  bid_head_color);
   ObjectSet(TAG+"bid", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"bid", OBJPROP_XDISTANCE, x+11);
   ObjectSet(TAG+"bid", OBJPROP_YDISTANCE, y+22);
   
   ObjectCreate(TAG+"spread", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"spread", s[8], 7, "Tahoma",  spread_color);
   ObjectSet(TAG+"spread", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"spread", OBJPROP_XDISTANCE, x+44);
   ObjectSet(TAG+"spread", OBJPROP_YDISTANCE, y+23);
          
   ObjectCreate(TAG+"a1", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"a1", s[1], 7, "Tahoma",  ask1_color);
   ObjectSet(TAG+"a1", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"a1", OBJPROP_XDISTANCE, x+51);
   ObjectSet(TAG+"a1", OBJPROP_YDISTANCE, y+31);
        
   ObjectCreate(TAG+"a2", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"a2", s[2], 17, "Tahoma",  ask2_color);
   ObjectSet(TAG+"a2", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"a2", OBJPROP_XDISTANCE, x+65);
   ObjectSet(TAG+"a2", OBJPROP_YDISTANCE, y+31);
      
   ObjectCreate(TAG+"a3", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"a3", s[3], 7, "Tahoma",  ask1_color);
   ObjectSet(TAG+"a3", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"a3", OBJPROP_XDISTANCE, x+89);
   ObjectSet(TAG+"a3", OBJPROP_YDISTANCE, y+43);

   ObjectCreate(TAG+"b1", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"b1", s[5], 7, "Tahoma",  bid1_color);
   ObjectSet(TAG+"b1", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"b1", OBJPROP_XDISTANCE, x+1);
   ObjectSet(TAG+"b1", OBJPROP_YDISTANCE, y+31);

   ObjectCreate(TAG+"b2", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"b2", s[6], 17, "Tahoma",  bid2_color);
   ObjectSet(TAG+"b2", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"b2", OBJPROP_XDISTANCE, x+15);
   ObjectSet(TAG+"b2", OBJPROP_YDISTANCE, y+31);
       
   ObjectCreate(TAG+"b3", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"b3", s[7], 7, "Tahoma",  bid1_color);
   ObjectSet(TAG+"b3", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"b3", OBJPROP_XDISTANCE, x+39);
   ObjectSet(TAG+"b3", OBJPROP_YDISTANCE, y+43);
   
   ObjectCreate(TAG+"clock", OBJ_LABEL, window, 0, 0);
   ObjectSetText(TAG+"clock", "H1 Bar End "+time, 8, "Tahoma",  time_color);
   ObjectSet(TAG+"clock", OBJPROP_CORNER, corner);
   ObjectSet(TAG+"clock", OBJPROP_XDISTANCE, x+1);
   ObjectSet(TAG+"clock", OBJPROP_YDISTANCE, y+53);

   WindowRedraw();

}



void GetSymbolInfo(string symbol)
{
   string as,bs;
   string spread;
   as = DoubleToStr(Ask,digits+1);
   bs = DoubleToStr(Bid,digits+1);
   spread = DoubleToStr((Ask - Bid)*mult,1);
   s[0] = as;
   s[3] = StringSubstr(as, StringLen(as)-2, 2);
   s[2] = StringSubstr(as, StringLen(as)-4, 2);
   s[1] = StringSubstr(s[0], 0 , StringLen(s[0])-4);
   s[4] = bs;
   s[7] = StringSubstr(s[4], StringLen(s[4])-2, 2);
   s[6] = StringSubstr(s[4], StringLen(s[4])-4, 2);
   s[5] = StringSubstr(s[4], 0 , StringLen(s[4])-4);
   s[8] = spread;
/*
   double S,R;
   int SC = 0;
   int RC = 0;
   int i;
   
   
   S = iCustom(pair,PERIOD_H1,"II_DSR",5,1,0);
   R = iCustom(pair,PERIOD_H1,"II_DSR",5,0,0);
   
   for(i=1;i<3;i++)
   {
      if (S == iCustom(pair,PERIOD_H1,"II_DSR",5,1,i)) SC = i;
      if (R == iCustom(pair,PERIOD_H1,"II_DSR",5,0,i)) RC = i;
   }
   pair_color = Eq;
   if (RC == 0 || RC == 1) pair_color = Up;
   if (SC == 0 || SC == 1) pair_color = Dn;
*/
}

//<Setup>
//<Clock>
string Clock(string symbol)
{
	double d;
   int m,s,k;
   m=iTime(symbol, 60, 0)-TimeCurrent();
   d=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
	m = 59 + m;
	s = 59 + s;
	
	if (m>=55) { time_color = Navy; return(""+m+" m "+s+" s ");}
	if (m>=50) { time_color = MidnightBlue; return(""+m+" m "+s+" s ");}
	if (m>=45) { time_color = DarkBlue; return(""+m+" m "+s+" s ");}
	if (m>=40) { time_color = DarkSlateBlue; return(""+m+" m "+s+" s ");}
	if (m>=35) { time_color = SteelBlue; return(""+m+" m "+s+" s ");}
	if (m>=30) { time_color = SlateGray; return(""+m+" m "+s+" s ");}
	if (m>=25) { time_color = Gray; return(""+m+" m "+s+" s ");}
	if (m>=20) { time_color = Maroon; return(""+m+" m "+s+" s ");}
	if (m>=15) { time_color = FireBrick; return(""+m+" m "+s+" s ");}
	if (m>=10) { time_color = Crimson; return(""+m+" m "+s+" s ");}
   if (m>=5) { time_color = OrangeRed; return(""+m+" m "+s+" s ");}
	if (m>=0) { time_color = Red; return(""+m+" m "+s+" s ");}

   return(""+m+"m "+s+"s");
}
//</CLOCK>
//<BarTimer>

void BarTimer(int XDistance,int YDistance)
{
   int i=0,sec=0;
   double pc=0.0;
   string time="",s_end="",s_beg="";
   if (ObjectFind(TAG+"BarTimer") == -1) {//     -    
     ObjectCreate(TAG+"BarTimer" , OBJ_LABEL,0,0,0);
     ObjectSet(TAG+"BarTimer", OBJPROP_XDISTANCE, XDistance);
     ObjectSet(TAG+"BarTimer", OBJPROP_YDISTANCE, YDistance);
     ObjectSet(TAG+"BarTimer", OBJPROP_CORNER, corner);
     ObjectSet(TAG+"BarTimer", OBJPROP_BACK, false);
   }
   sec=TimeCurrent()-Time[0];//      
   i=(lenbase-1)*sec/(Period()*60);//  
   pc=100.0*sec/(Period()*60);//      
   if(i>lenbase-1) i=lenbase-1;//    
   if(i>0) s_beg=StringSubstr(s_base,0,i);
   if(i<lenbase-1) s_end=StringSubstr(s_base,i+1,lenbase-i-1);
   time=StringConcatenate(s_beg,"|",s_end," ",DoubleToStr(pc,0),"%");
   ObjectSetText(TAG+"BarTimer", time, BarTimer.FontSize, BarTimer.FontName, BarTimer.Color);

   return(0);
}


//</BARTIMER>


//<DRAW CELL>
void DrawCell(int nWindow, string nCellName, double nX, double nY, double nWidth, double nHeight, color nColor, int cnr)
{
   double   iHeight, iWidth, iXSpace;
   int      iSquares, i;
   
   if(nWidth > nHeight)
   {
     iSquares = MathCeil(nWidth/nHeight);      // Number of squares used.
     iHeight  = MathRound((nHeight*100)/77);   // Real height size.
     iWidth   = MathRound((nWidth*100)/77);    // Real width size.
     iXSpace  = iWidth/iSquares - ((iHeight/(9-(nHeight/100)))*2);
     
      for(i=0;i<iSquares;i++)
      {
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iHeight, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX + iXSpace*i);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY);    
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }        
   }else{
      iSquares = MathCeil(nHeight/nWidth);      // Number of squares used.
      iHeight  = MathRound((nHeight*100)/77);   // Real height size.
      iWidth   = MathRound((nWidth*100)/77);    // Real width size.
      iXSpace  = iHeight/iSquares - ((iWidth/(9-(nWidth/100)))*2);   
 
      for(i=0;i<iSquares;i++)
      {
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iWidth, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY + iXSpace*i);    
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }       
   }
}
//</DRAW CELL>

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    